Subject: Re: [PATCH v2 14/14] difftool/mergetool: refactor commands to use git-mergetool--lib

From: David Aguilar <[email-masked]>
Date: Tue, 7 Apr 2009 00:07:46 -0700

On  0, Markus Heidelberg <[email-masked]> wrote:
> David Aguilar, 06.04.2009:
> > diff --git a/git-mergetool--lib.sh b/git-mergetool--lib.sh
> 
> > +run_merge_tool () {
> > +	base_present="$2"
> > +	if diff_mode; then
> > +		base_present="false"
> > +	fi
> > +	if test -z "$base_present"; then
> > +		base_present="true"
> > +	fi
> 
> The second if is never true, so isn't necessary. run_merge_tool() is
> called with $2 = true or false in mergetool and $2 = "" in difftool.
> 
> But I wonder, if it would be better to change the proceeding in the
> case-esac in the next hunk below:
> 
> Currently it is:
>     if $base_present
>         mergetool with base
>     else
>         if $merge_mode
>             mergetool without base
>         else
>             difftool
>         fi
>     fi
> 
> Maybe better:
>     if $merge_mode
>         if $base_present
>             mergetool with base
>         else
>             mergetool without base
>         fi
>     else
>         difftool
>     fi
> 
> Then the first if can vanish as well and $base_present doesn't have to
> be set to false in diff_mode.
> 
> And check_unchanged() doesn't have to be called in diff_mode any more,
> $status could be set to 0 by default and doesn't have to be touched when
> in diff_mode. Only in merge_mode git-mergetool has to know, whether the
> merge went fine.
> 
> Then it will be:
>     if $merge_mode
>         touch $BACKUP
>         if $base_present
>             mergetool with base
>         else
>             mergetool without base
>         fi
> 	check_unchanged
>     else
>         difftool
>     fi
> 
> or:
>     if $merge_mode
>         if $base_present
>             mergetool with base
>         else
>             mergetool without base
>         fi
> 	status=$?
>     else
>         difftool
>     fi
> 
> Sorry for coming so late with this.
> 

Nah, I like your suggestion much better.

> > +	if echo "${VISUAL:-$EDITOR}" | grep emacs > /dev/null 2>&1; then
> > +		# $EDITOR is emacs so add emerge as a candidate
> > +		tools="$tools emerge opendiff vimdiff"
> > +	elif echo "${VISUAL:-$EDITOR}" | grep vim > /dev/null 2>&1; then
> > +		# $EDITOR is vim so add vimdiff as a candidate
> > +		tools="$tools vimdiff opendiff emerge"
> > +	else
> > +		tools="$tools opendiff emerge vimdiff"
> > +	fi
> 
> Why is opendiff here? I thought the graphical tools should go above.
> Doesn't have Mac OS $DISPLAY set?

Good catch..
Ahh.. shoot I broke the foo.<tool>.path test on Mac OS
(no tkdiff to override there).
I'll have to redo that to use test-tool.

-- 

	David